#pragma once
#include "FIRFilter.h"
#include "DspFilter.h"
#include <stdlib.h>
#include <Windows.h>


class AntitrendFilter
{
public:
	//nLeads -  , avm -  ,   1.0  
	//sampleRate -  
	AntitrendFilter(int nLeads, int avm, int sampleRate);
	~AntitrendFilter(void);
	//  
	void process(float **data, int len);
	//  
	void reset();
	void setAVM(float val);
	void setSampleRate(int sampleRate);
private:
	int nInputLeads;
	int sampleRate;
	int avm;
	int trendOrder;
	float trendFreq;
	float trendFreqOutOfRange;
	float rangeLimit;
	float trendEnvFiltLength;
	Dsp::BesselHighPass<50, 1> * trendFilter;
	FIRFilter *envFilter;
	void processChunk(float **inpLeads, int inpLen);
};
